package cat.hack3.codingtests.marsrover.ui.console;

import cat.hack3.codingtests.marsrover.MarsRover;

import java.util.Scanner;

import static cat.hack3.codingtests.marsrover.ui.console.UICommons.isNotExitSignal;
import static cat.hack3.codingtests.marsrover.ui.console.UICommons.output;

public class RoverCommandsPerformer {
    private final Scanner reader;
    private final MarsRover rover;

    public RoverCommandsPerformer(Scanner reader, MarsRover rover) {
        this.reader = reader;
        this.rover = rover;
    }

    public void acceptCommandsUntilExitSignal() {
        var nextCommand = "none";
        do {
            output("Insert command (f = forward, b = backward, l = turn left, r = turn right, q = quit):");
            nextCommand = reader.next();
            switch (nextCommand) {
                case "f" -> rover.moveForward();
                case "b" -> rover.moveBackwards();
                case "l" -> rover.turnLeft();
                case "r" -> rover.turnRight();
                case "q" -> output("Disconnecting from Mars...");
                default -> output("unknown command");
            }
        } while (isNotExitSignal(nextCommand));
    }
}
